#!/bin/bash

# Script pour décrypter/crypter le fichier de passwords avec GPG
#  plutôt qu'avec python qui est plus que poussif.

# Pour ne pas avoir le pinentry gtk
export GPG_AGENT_INFO=

cd ~/.pass

FILE="pss"

# On décrypte
gpg --decrypt-files ${FILE}.gpg

# On édite le fichier
nano ${FILE}

echo -n "Save ? (o/N)"
read -r ans
if [[ ${ans} = "o" ]]
then
    echo "Backuping ${FILE}.gpg into ${FILE}.gpg.bkp1"
    cp ${FILE}.gpg ${FILE}.gpg.bkp1
    echo "Removing previous ${FILE}.gpg file"
    rm -f ${FILE}.gpg
    echo "Encrypting new ${FILE}.gpg"
    gpg --batch -r D5759143B14B45B6 --encrypt-files ${FILE}
    echo "Pense à copier ${FILE}.gpg.bkp1 en ${FILE}.gpg.bkp2"
else
    echo "Nothing saved."
fi


# On shred le fichier non encrypté
echo "Deleting not encrypted ${FILE}"
shred -n 10 -u ${FILE}
